architecture system_level of client_server_system is

    type result_value is new integer;
    type result_channel is channel of result_value;
    type result_ref is access result_channel;

    type request_info is
        record
	    request_id : integer; -- info for the transaction
	    result_please : result_ref;
        end record request_info;

    type request_channel is channel of request_info;
    type request_ref is access request_channel;


    process client is
        port ( channel request : out request_channel );

	variable result : result_ref := new result_channel;
        variable the_result_value : result_value;

    begin
	send ( 0, result ) to request;
	receive the_result_value from result.all;
	wait;	
    end process client;


    process server is
        port ( channel request : in request_channel );

        process agent is
	    port ( channel request : in request_channel );

	    variable info : request_info;

        begin
	    receive info from request;
	    null; -- perform transaction
	    send 0 to info.result_please.all;
	    terminate;
        end process agent;

        variable info : request_info;
        variable new_agent_request : request_ref;

    begin
	receive info from request;
	new_agent_request := new request_channel;
	process agent
	    port map ( request => new_agent_request.all );
        send info to new_agent_request.all;
    end process server;


    channel server_request : request_channel;

    constant number_of_clients : positive := 10;

begin

    the_server : process server
	port map ( request => server_request );

    client_pool : for client_index in 1 to number_of_clients generate

	a_client : process client
	    port map ( request => server_request );

    end generate client_pool;

end architecture system_level;
