package test_queues is
    
    use work.tests.all;

    type queue is limited access private;
    
    constant empty_queue : queue;
    
    procedure copy ( from_Q : in queue; to_Q : inout queue );
    
    impure function "=" ( L, R : in queue ) return boolean;
    impure function "/=" ( L, R : in queue ) return boolean;

    impure function is_empty ( Q : queue ) return boolean;
    
    procedure add ( Q : inout queue;  item : in test );
    
    procedure remove ( Q : inout queue;  item : out test );

private

    type queue_element;
    
    type queue_ptr is access queue_element;
    
    type queue_element is
        record
            the_test : test;
            next_element, prev_element : queue_ptr;
	end record queue_element;
    
    type queue is
        record
            head, tail : queue_ptr; 
	end record queue;
    
--    constant empty_queue : queue := queue'(null, null);
    
end package test_queues;
